using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MovieSandboxLib;

namespace Milchscanner
{
    public partial class MilchMain : Form
    {
        [STAThread]
        public static void Main(string[] args)
        {
            try
            {
                using (MilchMain form = new MilchMain())
                {
                    form.ShowDialog();
                }
            }
            catch { }
        }
        
        public MilchMain()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            videoWindow1.SetSimple();
            videoWindow1.simpleCapLink.threshhold = Convert.ToInt16(threshholdText.Text);
            int colorValue = Convert.ToInt16(colorValueBox.Text);
            videoWindow1.simpleCapLink.myColor = Color.FromArgb(colorValue, colorValue, colorValue);
            videoWindow1.simpleCapLink.startCaptureVideoWindow(0);
        }

        private void threshholdText_TextChanged(object sender, EventArgs e)
        {
            if (videoWindow1.simpleCapLink != null)
            {

                if (threshholdText.Text != "" && videoWindow1.simpleCapLink != null)
                {
                    videoWindow1.simpleCapLink.threshhold = Convert.ToInt16(threshholdText.Text);
                    threshHoldBar.Value = Convert.ToInt16(threshholdText.Text);
                }
            }
        }

        private void shiftButton_Click(object sender, EventArgs e)
        {
            if (videoWindow1.simpleCapLink != null)
            {
                Bitmap b = new Bitmap(videoWindow1.simpleCapLink.videoWidth, videoWindow1.simpleCapLink.videoHeight);

                if (pictureBox1.Image != null)
                    b = new Bitmap(pictureBox1.Image);

                videoWindow1.simpleCapLink.stop();
                videoWindow1.simpleCapLink.CopyToTarget(b);
                pictureBox1.Image = (Image)b;
                videoWindow1.simpleCapLink.play();
                b = null;
                GC.Collect();
                int myValue = Convert.ToInt16(colorValueBox.Text);
                myValue += Convert.ToInt16(stepValueBox.Text);
                if (myValue > 255)
                    myValue = 255;
                colorValueBox.Text = myValue.ToString();
            }
        }

        private void colorValueBox_TextChanged(object sender, EventArgs e)
        {
            int colorValue = 0;
            if (videoWindow1.simpleCapLink != null)
            {

                if (colorValueBox.Text != "")
                {
                    colorValue = Convert.ToInt16(colorValueBox.Text);
                    heightBar.Value = Convert.ToInt16(colorValueBox.Text);
                }
                videoWindow1.simpleCapLink.myColor = Color.FromArgb(colorValue, colorValue, colorValue);
            }
        }

        private void SaveHeight_Click(object sender, EventArgs e)
        {
            if (pictureBox1.Image != null)
            {
                if (saveHeightDialog.ShowDialog()==DialogResult.OK)
                pictureBox1.Image.Save(saveHeightDialog.FileName, System.Drawing.Imaging.ImageFormat.Bmp);
            }
        }

        private void heightBar_Scroll(object sender, ScrollEventArgs e)
        {
            colorValueBox.Text = heightBar.Value.ToString();
            colorValueBox_TextChanged(sender, e);
        }

        private void threshHoldBar_Scroll(object sender, ScrollEventArgs e)
        {
            threshholdText.Text = threshHoldBar.Value.ToString();
            threshholdText_TextChanged(sender, e);
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (videoWindow1.simpleCapLink!=null)    
              videoWindow1.simpleCapLink.fluidSelect = comboBox1.SelectedIndex;
        }
    }
}