using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using System.Drawing;

namespace MovieSandboxLib
{
    public class VideoWindow : PictureBox
    {
        private System.ComponentModel.IContainer components;
        public CaptureClass capLink;
        public SimpleCaptureClass simpleCapLink;

        public VideoWindow()
        {
            InitializeComponent();
        }

        private void InitializeComponent()
        {
            ((System.ComponentModel.ISupportInitialize)(this)).BeginInit();
            this.SuspendLayout();
            // 
            // VideoWindow
            // 
            ((System.ComponentModel.ISupportInitialize)(this)).EndInit();
            this.ResumeLayout(false);
        }

        public void CloseInterfaces()
        {
            if (capLink!=null)
                capLink.CloseInterfaces();
            
            if (simpleCapLink!=null)
                simpleCapLink.CloseInterfaces();
         }
        
        protected override void Dispose(bool disposing)
        {
            if (capLink != null)
                capLink.Dispose();

            if (simpleCapLink != null)
                simpleCapLink.Dispose();

            base.Dispose(disposing);
        }

        public void SetSimple()
        {
            simpleCapLink = new SimpleCaptureClass(this);
        }

        public void createCapLink()
        {
            capLink = new CaptureClass(this);
            Console.WriteLine(capLink.ToString());
        }

    }
}
