using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace MovieSandboxLib
{
    public partial class draggablePictureBox : PictureBox
    {
        private bool bDragged;
        private double deltaMousePositionX;
        private double oldMousePositionX;
        private double deltaMousePositionY;
        private double oldMousePositionY;
        public int linkAxis;                // 0 for X-Axis, 1 for Y Axis, 2 for both

        private draggablePictureBox _ParentBone;

        public draggablePictureBox ParentBone
        {
            get { return _ParentBone; }
            set { _ParentBone = value; }
        }

        private draggablePictureBox _LinkedBone;

        public draggablePictureBox LinkedBone
        {
            get { return _LinkedBone; }
            set { _LinkedBone = value; }
        }


        public draggablePictureBox()
        {
            InitializeComponent();
        }

        private void draggablePictureBox_MouseDown(object sender, MouseEventArgs e)
        {
            bDragged = true;
        }

        private void draggablePictureBox_MouseUp(object sender, MouseEventArgs e)
        {
            bDragged = false;
        }

        private void draggablePictureBox_MouseCaptureChanged(object sender, EventArgs e)
        {
            
        }

        private void checkDragged_Tick(object sender, EventArgs e)
        {
            deltaMousePositionX = MousePosition.X - oldMousePositionX;
            deltaMousePositionY = MousePosition.Y - oldMousePositionY;
            if (bDragged)
            {
                Left += (int)deltaMousePositionX;
                Top += (int)deltaMousePositionY;
                if (LinkedBone != null)
                {
                    if (linkAxis!=1)
                      LinkedBone.Left +=(int)deltaMousePositionX;
                    if (linkAxis>0)
                      LinkedBone.Top += (int)deltaMousePositionY;
                }
            }
            oldMousePositionX=MousePosition.X;
            oldMousePositionY = MousePosition.Y;
        }        
    }
}